*	FILE: Compito.inc
*	
*	Include file for package COMPITO
*


*	parameters

	INCLUDE 'parameters.inc'
        INCLUDE 'solution.inc'

*	control variables

	COMMON /control/ n_named, n_spares, n_skip, icomp, iseed,
     &	                 n_digits, tex, many_outputs, var_delimiter

	INTEGER n_named			! number of named tests (compiti)
	INTEGER n_spares		! number of spare tests (compiti)
	INTEGER n_skip			! number of skipped tests (compiti)
	INTEGER icomp			! current test number
	INTEGER iseed			! random seed
	INTEGER n_digits		! number of significant digits
	LOGICAL tex			! TEX output
	LOGICAL many_outputs		! one output file per test
	CHARACTER*1 var_delimiter	! delimiter of variables in text, NOTE:
					! it MUST be 1 character only


*	input and output text

	COMMON /inout_text/ max_char,
     &	                 last_text,   text(max_line), ltex(max_line),
     &	                 last_range, range(max_line), lran(max_line),
     &	                 last_solve, solve(max_line), lsol(max_line),
     &	                 last_cons,   cons(max_line), lcon(max_line),
     &                   last_forc,   forc(max_line), lfor(max_line),
     &	                          out_text(max_line), lout(max_line),
     &	                 last_name,   name(max_line), lnam(max_line),
     &	 add(max_line,n_alternatives), ladd(max_line,n_alternatives)

	INTEGER max_char			! max number of characters in
						! text, range or solution line
	INTEGER last_text			! last text line
	INTEGER ltex				! text line length
	INTEGER last_range			! last range line
	INTEGER lran				! range line length
	INTEGER last_solve			! last solution line
	INTEGER lsol				! solution line length
	INTEGER last_cons			! last constraint line
	INTEGER lcon				! constraint line length
	INTEGER last_forc                       ! last forced answer line
	INTEGER lfor                            ! forced answer line length
	INTEGER lout				! output text line length
	INTEGER last_name			! last name line
	INTEGER lnam				! name line length
	INTEGER ladd				! length of additional text
*	input text and other string arrays/variables
*	(variable "string" is not in common, but it is declared here
*	 to guarantee same size of other strings)
	CHARACTER*400 text, range, solve, cons, forc, 
     &                out_text, name, string
	CHARACTER*100 add			! additional output text


*	random variables

	COMMON /random/ random_value(max_var)

	REAL random_value			! current random value

	COMMON /variables/ linevar(max_var), jfirst(max_var), 
     1                     jlast(max_var),
     1	                   lv(max_var), var(max_var), 
     1                     sav(max_var), nvar,
     1	                   rlow(max_var), rup(max_var)

	INTEGER linevar		! text line where a variable is found
	INTEGER jfirst		! pointer to first character of variable
	INTEGER jlast		! pointer to last character of variable
	INTEGER lv		! variable length in characters
	CHARACTER*15 var, sav	! variable's names
	INTEGER nvar		! number of found variables
	REAL rlow		! lower edge of variable's range
	REAL rup		! upper edge of variable's range


*	questions and answers

	COMMON /questions/ weights(max_question,2),
     &                     n_questions, icorrect(max_question),
     &	                   line_question(max_question),
     &	                   draw_sign(max_question),
     &                     int_ans(max_question),
     &                     lit_ans(max_question),
     &                     bot_ans(max_question),
     &                     iforced(max_forced)

        INTEGER weights		! weights of each question
	INTEGER n_questions	! number of found questions in text
	INTEGER icorrect	! position of correct solution (1=A, 2=B, etc.)
	INTEGER line_question	! text line where "answer_line" word was found
C	REAL altern		! proposed alternative answers
	LOGICAL draw_sign	! flag on sign of alternative
        LOGICAL int_ans         ! flag on integer alternatives
        LOGICAL lit_ans         ! flag on literal answers
	LOGICAL bot_ans		! flag for both literal and numerical answers
        INTEGER iforced		! position of forced answer
				! max_forced*n_questions + iforced


*	solutions to current problem
c
c	INCLUDE 'solution.inc'

