      SUBROUTINE find_questions

*	This procedure looks for the answer lines to be put in the text.
*	These lines are identified by the appropriate control word
*	(COMPITO package)

      IMPLICIT NONE
      SAVE

      INCLUDE 'compito.inc'

      INTEGER i,j         ! loop index
      INTEGER iret		! return code
      INTEGER jpoi		! string pointer
      INTEGER jpo2              ! string pointer
      REAL check        ! check solutions
C Note by R Mannella 19/01/96
C variable check introduced to handle SOLUTION(i) = 0.
      PARAMETER (check = -9.99e9)

*	External function
      INTEGER STRUPCASE	! Convert to uppercase (Run-time library)


*	Executable code


*	initialize counter of questions
      n_questions = 0
      jpo2 = 0
	

*	  search all questions (identified by the control word
*	  in character string "answer_line")

	  DO 30000, i = 1, last_text		! loop on text lines

	  iret = STRUPCASE (string, text(i), len(text(i)))
	  jpoi = INDEX (string, answer_line)
          IF (INDEX(string, literal_answer) .NE. 0 .and.
     +         jpoi .ne. 0) jpo2 = jpo2 + 1
          
          
	    IF (jpoi .NE. 0)  THEN

	      n_questions = n_questions + 1
              lit_ans(n_questions) = INDEX(string, literal_answer).NE.0


	        IF (n_questions .GT. max_question)  THEN

	          PRINT *, ' '
	          PRINT *, ' FIND_QUESTIONS: too many questions found'
	          PRINT *, ' maximum allowed (max_question):', max_question
	          PRINT *, ' exceeding question found on text line:', i
	          PRINT *, ' ', text(i)(1:ltex(i))
	          PRINT *, ' the control word (answer_line) is ', answer_line
	          PRINT *, ' '
	          CALL LIBSTOP (%VAL(ss_abort))

	        END IF

	      line_question(n_questions) = i
	      jpoi = INDEX (string, unstable_sign)
	      draw_sign(n_questions) = jpoi .NE. 0
C Next switch: isidoro.ferrante@pi.infn.it 28/3/2000
C to handle integer random answers (flag INT, like FLIP)
              jpoi = INDEX (string, integer_answer)
              int_ans(n_questions) = jpoi .NE. 0

C Switch to generate an analytical answer
              jpoi = INDEX (string, literal_answer)
              lit_ans(n_questions) = jpoi .NE. 0

C Switch to generate both numerical and analytical answers
              jpoi = INDEX (string, both_answer)
              bot_ans(n_questions) = jpoi .NE. 0

	    END IF


30000	  CONTINUE				! end of loop on text lines


      PRINT *, ' Number of questions found in text:', n_questions



*	check consistency between found questions and SOLUTION section in text

*	  zero the solutions' array

	  DO i = 1, max_question
	  solution(i) = check
	  END DO

*	generate a set of variables
      CALL generate_variables

*	calculate solutions
      CALL evaluate_solution

*	look for modified solution cells

c      n_solutions = max_question
       n_solutions = 0
       DO i = 1,max_question
          IF(solution(i) .NE. check) n_solutions = n_solutions + 1
       ENDDO

c	  DO WHILE (solution(n_solutions) .EQ. check)

c	  n_solutions = n_solutions - 1
 
	    IF (n_solutions+jpo2 .EQ. 0)  THEN

	      PRINT *, ' '
	      PRINT *, '       ***      WARNING  !      ***'
	      PRINT *, ' '
	      PRINT *, ' number of solutions in section SOLUTION',
     &	              ' seems to be ZERO'
	      PRINT *, ' '
	      PRINT *, ' NON-FATAL error, execution continues'
	      PRINT *, ' '
	      GO TO 50000

	    END IF

c	  END DO

         print *,n_solutions,'n solutions',jpo2
50000	CONTINUE

	  IF (n_solutions+jpo2 .NE. n_questions)  THEN

	    PRINT *, ' '
	    PRINT *, ' FIND_QUESTIONS: questions/solutions mismatch'
	    PRINT *, ' number of questions seems to be different from',
     &	            ' number of solutions'
	    PRINT *, ' number of questions:', n_questions
	    PRINT *, ' number of solutions:', n_solutions
	    PRINT 50100, n_solutions
50100	    FORMAT (1X, ' last solution active in section SOLUTION is:',
     &	                ' SOLUTION(', I2, ')')
	    PRINT *, ' '
	    CALL LIBSTOP (%VAL(ss_abort))

	  END IF

*	  check that all solution cells are modified

	  DO i = 1, n_questions ! n_solutions

	    IF (solution(i) .EQ. check .AND. .NOT.lit_ans(i))  THEN

	      PRINT *, ' '
	      PRINT *, ' FIND_QUESTIONS: missing solution in section SOLUTION'
	      PRINT 55100, i
55100	      FORMAT (1X, ' missing solution is: SOLUTION(', I2, ')')
	      PRINT *, ' '
	      CALL LIBSTOP (%VAL(ss_abort))

	    END IF

	  END DO

C The solutions are now checked. Proceed to guess the weights
      j = 1
c      print *,"Check again",n_questions,jpo2
      DO i = 1, n_questions ! n_solutions
         string = text(line_question(i)-2)

         DO jpoi = 1,len(string)-5
c            print *,jpoi,string(jpoi:jpoi)
            IF (string(jpoi:jpoi) .EQ. '(') THEN
c               print *,jpoi,string(jpoi:jpoi)
               IF (string(jpoi+2:jpoi+2) .EQ. ',') THEN
                  IF (string(jpoi+5:jpoi+5) .EQ. ')') THEN
                      weights(j,1) = ichar(string(jpoi+1:jpoi+1))-48
                      weights(j,2) = -(ichar(string(jpoi+4:jpoi+4))-48)
                      j = j + 1 
                  ENDIF
                  IF (string(jpoi+4:jpoi+4) .EQ. ')') THEN
                      weights(j,1) = ichar(string(jpoi+1:jpoi+1))-48
                      weights(j,2) = ichar(string(jpoi+3:jpoi+3))-48 
                      j = j + 1
                  ENDIF
               ENDIF
            ENDIF
         ENDDO
      ENDDO
      CLOSE(14)

      RETURN

      END

