	SUBROUTINE prepare_format (xx, convert, form, length, ixx, intgr)

*	This procedure writes the "optimal" format.
*	Input	-	xx, convert
*	Output	-	form, length, ixx, intgr
*	(COMPITO package)

	IMPLICIT NONE
	SAVE

	INCLUDE 'M$INF:compito.inc/LIST'


*	I/O parameters
	REAL xx				! IN:  real value
	LOGICAL convert			! IN:  convert input to integer
	CHARACTER*8 form		! OUT: format string
	INTEGER length			! OUT: format length
	INTEGER ixx			! OUT: input converted to integer
	LOGICAL intgr			! OUT: input was converted to "ixx"

*	other local variables
	INTEGER ninteger, ndecimal	! number of places for the
	INTEGER nsign, ntotal		! F format of a variable
	LOGICAL big_enough		! flag
	LOGICAL small_enough		! flag

*	external functions
	INTEGER k_exp			! exponent in scientific notation


*	Executable code


*	initialize return code
	intgr = .FALSE.

*	evaluate integer, decimal and total places for F format,
*	allowing one place for decimal dot
	ninteger = MAX (1, k_exp (xx))
	ndecimal = MAX (0, n_digits - k_exp (xx))
	nsign = MAX (0, NINT (-SIGN (1., xx)))
	ntotal = ninteger + ndecimal + nsign + 1

*	  prepare format

	  IF (ntotal .LE. max_format)  THEN

	    length = ntotal
	    WRITE (form, 1000) ntotal, ndecimal
1000	    FORMAT ('(F', I2, '.', I2, ')')

	  ELSE

	    length = n_digits + nsign + 6
	    WRITE (form, 1100) length, n_digits
1100	    FORMAT ('(E', I2, '.', I2, ')')

	  END IF

	big_enough = ABS (xx)  .GE.  (10. ** (n_digits-1))
	small_enough = ABS (xx)  .LT.  (10. ** (max_format-1))

	  IF (convert .AND. big_enough .AND. small_enough)  THEN

	    ixx = NINT (xx)
	    intgr = .TRUE.
	    length = ninteger + nsign
	    WRITE (form, 1200) length
1200	    FORMAT ('(I', I2, '   ', ')')

	  END IF


	RETURN

	END
