	SUBROUTINE write_test_constraint

*	This routine writes the FORTRAN code for
*	the subroutine that checks the user's constraints.
*	(COMPITO package)

	IMPLICIT NONE
	SAVE

	INCLUDE 'compito.inc'

	INTEGER i			! loop index


*	Executable code


*	open output file
	OPEN (UNIT=21, FILE='test_constraint.f', ACCESS='SEQUENTIAL',
     &	      STATUS='NEW', FORM='FORMATTED') !, CARRIAGECONTROL='LIST')


*	header

	WRITE (21, '(A)') '      SUBROUTINE test_constraint (good)'
	WRITE (21, '(A)') ' '
	WRITE (21, '(A)') '*     This routine evaluates the current solutions'
	WRITE (21, '(A)') '*     (COMPITO package)'
	WRITE (21, '(A)') ' '
	WRITE (21, '(A)') '*     Author: Routine WRITE_TEST_CONSTRAINT'
	WRITE (21, '(A)') ' '
	WRITE (21, '(A)') '      IMPLICIT NONE'
	WRITE (21, '(A)') '      SAVE'
	WRITE (21, '(A)') ' '
	WRITE (21, '(A)') '      INCLUDE ''parameters.inc'''
	WRITE (21, '(A)') ' '
	WRITE (21, '(A)') '      INCLUDE ''solution.inc'''
	WRITE (21, '(A)') ' '
	WRITE (21, '(A)') '      LOGICAL good		! flag on constraints'
	WRITE (21, '(A)') '				! output variable'
	WRITE (21, '(A)') '      INTEGER i		! loop index'
	WRITE (21, '(A)') ' '


*	  declaration of random variables

	  IF (nvar .GE. 1)  THEN

	    WRITE (21, '(A)') '      COMMON /random/'
	    WRITE (21, '(A13, (A))') '     &       ', var(1)(1:lv(1))

	      DO i = 2, nvar
	      WRITE (21, '(A13, (A))') '     &  ,    ', var(i)(1:lv(i))
	      END DO

	      DO i = 1, nvar
	      WRITE (21, '(A11, (A))') '      REAL ', var(i)(1:lv(i))
	      END DO

	    WRITE (21, '(A)') ' '

	  END IF


*	  user's code from section CONSTRAINT of input text file

	  DO i = 1, last_cons
	  WRITE (21, '(A)') cons(i)(1:lcon(i))
	  END DO


*	put all constraints in logical AND

	WRITE (21, '(A)') ' '
	WRITE (21, '(A)') '      good = .TRUE.'
	WRITE (21, '(A)') ' '
	WRITE (21, '(A)') '      DO i = 1, max_constraint'
	WRITE (21, '(A)') '         good = good .AND. constraint(i)'
	WRITE (21, '(A)') '      END DO'


*	footer

	WRITE (21, '(A)') ' '
	WRITE (21, '(A)') ' '
	WRITE (21, '(A)') '      RETURN'
	WRITE (21, '(A)') ' '
	WRITE (21, '(A)') '      END'


	CLOSE (21)

	RETURN

	END
